"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeBytesNode = exports.isTypeBytesNode = exports.TypeBytesNode = void 0;
class TypeBytesNode {
    constructor(options = {}) {
        var _a;
        this.nodeClass = 'TypeBytesNode';
        this.size = (_a = options.size) !== null && _a !== void 0 ? _a : { kind: 'variable' };
    }
    accept(visitor) {
        return visitor.visitTypeBytes(this);
    }
    getSizeAsString() {
        if (this.size.kind === 'fixed')
            return `${this.size.bytes}`;
        if (this.size.kind === 'prefixed')
            return `${this.size.prefix.toString()}`;
        return 'variable';
    }
    toString() {
        return `bytes(${this.getSizeAsString()})`;
    }
}
exports.TypeBytesNode = TypeBytesNode;
function isTypeBytesNode(node) {
    return !!node && node.nodeClass === 'TypeBytesNode';
}
exports.isTypeBytesNode = isTypeBytesNode;
function assertTypeBytesNode(node) {
    var _a;
    if (!isTypeBytesNode(node)) {
        throw new Error(`Expected TypeBytesNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeBytesNode = assertTypeBytesNode;
//# sourceMappingURL=TypeBytesNode.js.map