"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeNumberNode = exports.isTypeNumberNode = exports.TypeNumberNode = void 0;
class TypeNumberNode {
    constructor(format, options = {}) {
        var _a;
        this.nodeClass = 'TypeNumberNode';
        this.format = format;
        this.endian = (_a = options.endian) !== null && _a !== void 0 ? _a : 'le';
    }
    accept(visitor) {
        return visitor.visitTypeNumber(this);
    }
    isSignedInteger() {
        return this.format.startsWith('i');
    }
    isUnsignedInteger() {
        return this.format.startsWith('u');
    }
    isInteger() {
        return !this.format.startsWith('f');
    }
    isDecimal() {
        return this.format.startsWith('f');
    }
    toString() {
        return `${this.format}(${this.endian})`;
    }
}
exports.TypeNumberNode = TypeNumberNode;
function isTypeNumberNode(node) {
    return !!node && node.nodeClass === 'TypeNumberNode';
}
exports.isTypeNumberNode = isTypeNumberNode;
function assertTypeNumberNode(node) {
    var _a;
    if (!isTypeNumberNode(node)) {
        throw new Error(`Expected TypeNumberNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeNumberNode = assertTypeNumberNode;
//# sourceMappingURL=TypeNumberNode.js.map