"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeStringNode = exports.isTypeStringNode = exports.TypeStringNode = void 0;
const TypeNumberNode_1 = require("./TypeNumberNode");
class TypeStringNode {
    constructor(options = {}) {
        var _a, _b;
        this.nodeClass = 'TypeStringNode';
        this.size = (_a = options.size) !== null && _a !== void 0 ? _a : {
            kind: 'prefixed',
            prefix: new TypeNumberNode_1.TypeNumberNode('u32'),
        };
        this.encoding = (_b = options.encoding) !== null && _b !== void 0 ? _b : 'utf8';
    }
    accept(visitor) {
        return visitor.visitTypeString(this);
    }
    getSizeAsString() {
        if (this.size.kind === 'fixed')
            return `${this.size.bytes}`;
        if (this.size.kind === 'prefixed')
            return `${this.size.prefix.toString()}`;
        return 'variable';
    }
    toString() {
        return `string(${this.encoding};${this.getSizeAsString()})`;
    }
}
exports.TypeStringNode = TypeStringNode;
function isTypeStringNode(node) {
    return !!node && node.nodeClass === 'TypeStringNode';
}
exports.isTypeStringNode = isTypeStringNode;
function assertTypeStringNode(node) {
    var _a;
    if (!isTypeStringNode(node)) {
        throw new Error(`Expected TypeStringNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeStringNode = assertTypeStringNode;
//# sourceMappingURL=TypeStringNode.js.map