"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseThrowVisitor = void 0;
class BaseThrowVisitor {
    visitRoot(root) {
        throw new Error('This visitor does not support Root nodes.');
    }
    visitProgram(program) {
        throw new Error('This visitor does not support Program nodes.');
    }
    visitAccount(account) {
        throw new Error('This visitor does not support Account nodes.');
    }
    visitInstruction(instruction) {
        throw new Error('This visitor does not support Instruction nodes.');
    }
    visitDefinedType(definedType) {
        throw new Error('This visitor does not support DefinedType nodes.');
    }
    visitError(error) {
        throw new Error('This visitor does not support Error nodes.');
    }
    visitTypeArray(typeArray) {
        throw new Error('This visitor does not support TypeArray nodes.');
    }
    visitTypeDefinedLink(typeDefinedLink) {
        throw new Error('This visitor does not support TypeDefinedLink nodes.');
    }
    visitTypeEnum(typeEnum) {
        throw new Error('This visitor does not support TypeEnum nodes.');
    }
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant) {
        throw new Error('This visitor does not support TypeEnumEmptyVariant nodes.');
    }
    visitTypeEnumStructVariant(typeEnumStructVariant) {
        throw new Error('This visitor does not support TypeEnumStructVariant nodes.');
    }
    visitTypeEnumTupleVariant(typeEnumTupleVariant) {
        throw new Error('This visitor does not support TypeEnumTupleVariant nodes.');
    }
    visitTypeMap(typeMap) {
        throw new Error('This visitor does not support TypeMap nodes.');
    }
    visitTypeOption(typeOption) {
        throw new Error('This visitor does not support TypeOption nodes.');
    }
    visitTypeSet(typeSet) {
        throw new Error('This visitor does not support TypeSet nodes.');
    }
    visitTypeStruct(typeStruct) {
        throw new Error('This visitor does not support TypeStruct nodes.');
    }
    visitTypeStructField(typeStructField) {
        throw new Error('This visitor does not support TypeStructField nodes.');
    }
    visitTypeTuple(typeTuple) {
        throw new Error('This visitor does not support TypeTuple nodes.');
    }
    visitTypeBool(typeBool) {
        throw new Error('This visitor does not support TypeBool nodes.');
    }
    visitTypeBytes(typeBytes) {
        throw new Error('This visitor does not support TypeBytes nodes.');
    }
    visitTypeNumber(typeNumber) {
        throw new Error('This visitor does not support TypeNumber nodes.');
    }
    visitTypeNumberWrapper(typeNumberWrapper) {
        throw new Error('This visitor does not support TypeNumberWrapper nodes.');
    }
    visitTypePublicKey(typePublicKey) {
        throw new Error('This visitor does not support TypePublicKey nodes.');
    }
    visitTypeString(typeString) {
        throw new Error('This visitor does not support TypeString nodes.');
    }
}
exports.BaseThrowVisitor = BaseThrowVisitor;
//# sourceMappingURL=BaseThrowVisitor.js.map