"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoSetAccountGpaFieldsVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const aggregators_1 = require("../aggregators");
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
class AutoSetAccountGpaFieldsVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(options = {}) {
        var _a, _b;
        super([
            {
                selector: { type: 'AccountNode' },
                transformer: (node) => {
                    nodes.assertAccountNode(node);
                    if (!this.override && node.metadata.gpaFields.length > 0)
                        return node;
                    if (nodes.isTypeDefinedLinkNode(node.type))
                        return node;
                    let offset = 0;
                    const gpaFields = node.type.fields.map((field) => {
                        const fieldOffset = offset;
                        if (offset !== null) {
                            const newOffset = field.type.accept(this.sizeVisitor);
                            offset = newOffset !== null ? offset + newOffset : null;
                        }
                        return {
                            name: field.name,
                            offset: fieldOffset,
                            type: field.type,
                        };
                    });
                    return new nodes.AccountNode({ ...node.metadata, gpaFields }, node.type);
                },
            },
        ]);
        this.override = (_a = options.override) !== null && _a !== void 0 ? _a : false;
        this.sizeVisitor = (_b = options.sizeVisitor) !== null && _b !== void 0 ? _b : new aggregators_1.GetByteSizeVisitor();
    }
    visitRoot(root) {
        if (this.sizeVisitor.registerDefinedTypes) {
            this.sizeVisitor.registerDefinedTypes(root.allDefinedTypes);
        }
        return super.visitRoot(root);
    }
}
exports.AutoSetAccountGpaFieldsVisitor = AutoSetAccountGpaFieldsVisitor;
//# sourceMappingURL=AutoSetAccountGpaFieldsVisitor.js.map