"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoSetFixedAccountSizesVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const aggregators_1 = require("../aggregators");
const BaseThrowVisitor_1 = require("../BaseThrowVisitor");
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
class AutoSetFixedAccountSizesVisitor extends BaseThrowVisitor_1.BaseThrowVisitor {
    visitRoot(root) {
        // Prepare the visitor that gets the byte size of a type.
        const byteSizeVisitor = new aggregators_1.GetByteSizeVisitor();
        byteSizeVisitor.registerDefinedTypes(root.allDefinedTypes);
        // Prepare the visitor that transforms account nodes.
        const transformVisitor = new TransformNodesVisitor_1.TransformNodesVisitor([
            {
                selector: (node) => nodes.isAccountNode(node) && node.metadata.size === null,
                transformer: (node) => {
                    nodes.assertAccountNode(node);
                    const size = node.type.accept(byteSizeVisitor);
                    if (size === null)
                        return node;
                    return new nodes.AccountNode({ ...node.metadata, size }, node.type);
                },
            },
        ]);
        // Execute the transform visitor on the Root node.
        const transformedRoot = root.accept(transformVisitor);
        nodes.assertRootNode(transformedRoot);
        return transformedRoot;
    }
}
exports.AutoSetFixedAccountSizesVisitor = AutoSetFixedAccountSizesVisitor;
//# sourceMappingURL=AutoSetFixedAccountSizesVisitor.js.map