"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateAccountsVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const utils_1 = require("../../utils");
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
const _renameHelpers_1 = require("./_renameHelpers");
class UpdateAccountsVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(map) {
        const transforms = Object.entries(map).map(([selector, updates]) => {
            const selectorStack = selector.split('.');
            const name = selectorStack.pop();
            return {
                selector: { type: 'AccountNode', stack: selectorStack, name },
                transformer: (node, stack, program) => {
                    var _a, _b;
                    nodes.assertAccountNode(node);
                    if (typeof updates === 'function') {
                        return updates(node, stack, program);
                    }
                    if ('delete' in updates) {
                        return null;
                    }
                    const newName = (0, utils_1.mainCase)((_a = updates.name) !== null && _a !== void 0 ? _a : node.name);
                    const data = (_b = updates.data) !== null && _b !== void 0 ? _b : {};
                    const newGpaFields = node.metadata.gpaFields.map((f) => {
                        var _a;
                        return ({
                            ...f,
                            name: (_a = data[f.name]) !== null && _a !== void 0 ? _a : f.name,
                        });
                    });
                    const newMetadata = {
                        ...node.metadata,
                        gpaFields: newGpaFields,
                        ...updates,
                    };
                    if (nodes.isTypeStructNode(node.type)) {
                        return new nodes.AccountNode(newMetadata, (0, _renameHelpers_1.renameStructNode)(node.type, data, newName));
                    }
                    return new nodes.AccountNode(newMetadata, node.type);
                },
            };
        });
        super(transforms);
        this.map = map;
    }
}
exports.UpdateAccountsVisitor = UpdateAccountsVisitor;
//# sourceMappingURL=UpdateAccountsVisitor.js.map