"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UseCustomInstructionSerializerVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const utils_1 = require("../../utils");
const BaseNodeVisitor_1 = require("../BaseNodeVisitor");
class UseCustomInstructionSerializerVisitor extends BaseNodeVisitor_1.BaseNodeVisitor {
    constructor(map) {
        super();
        this.map = Object.entries(map).reduce((acc, [selector, options]) => ({
            ...acc,
            [(0, utils_1.mainCase)(selector)]: parseLink(selector, options),
        }), {});
    }
    visitProgram(program) {
        const newDefinedTypes = program.definedTypes;
        program.instructions.forEach((instruction) => {
            var _a;
            const options = (_a = this.map[instruction.name]) !== null && _a !== void 0 ? _a : null;
            if (!options || !options.extract)
                return;
            if (nodes.isTypeDefinedLinkNode(instruction.args))
                return;
            const newType = new nodes.DefinedTypeNode({
                name: options.extractAs,
                idlName: instruction.metadata.idlName,
                docs: instruction.metadata.docs,
                internal: options.extractedTypeShouldBeInternal,
            }, instruction.args);
            newDefinedTypes.push(newType);
        });
        return new nodes.ProgramNode(program.metadata, program.accounts, program.instructions
            .map((instruction) => instruction.accept(this))
            .filter(nodes.assertNodeFilter(nodes.assertInstructionNode)), newDefinedTypes, program.errors);
    }
    visitInstruction(instruction) {
        var _a;
        const options = (_a = this.map[instruction.name]) !== null && _a !== void 0 ? _a : null;
        if (!options)
            return instruction;
        if (nodes.isTypeDefinedLinkNode(instruction.args))
            return instruction;
        return new nodes.InstructionNode(instruction.metadata, instruction.accounts, new nodes.TypeDefinedLinkNode(options.name, {
            dependency: options.dependency,
        }), instruction.subInstructions);
    }
}
exports.UseCustomInstructionSerializerVisitor = UseCustomInstructionSerializerVisitor;
function parseLink(name, link) {
    const defaultOptions = {
        name: `${name}InstructionData`,
        dependency: 'hooked',
        extract: false,
        extractAs: `${name}InstructionData`,
        extractedTypeShouldBeInternal: true,
    };
    const options = typeof link === 'boolean' ? defaultOptions : { ...defaultOptions, ...link };
    return {
        ...options,
        name: (0, utils_1.mainCase)(options.name),
        extractAs: (0, utils_1.mainCase)(options.extractAs),
    };
}
//# sourceMappingURL=UseCustomInstructionSerializerVisitor.js.map