import type { IdlDefinedType } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
export type DefinedTypeNodeMetadata = {
    name: string;
    idlName: string;
    docs: string[];
    internal: boolean;
};
export declare class DefinedTypeNode implements Visitable {
    readonly nodeClass: "DefinedTypeNode";
    readonly metadata: DefinedTypeNodeMetadata;
    readonly type: TypeNode;
    constructor(metadata: DefinedTypeNodeMetadata, type: TypeNode);
    static fromIdl(idl: Partial<IdlDefinedType>): DefinedTypeNode;
    accept<T>(visitor: Visitor<T>): T;
    get name(): string;
    get docs(): string[];
}
export declare function isDefinedTypeNode(node: Node | null): node is DefinedTypeNode;
export declare function assertDefinedTypeNode(node: Node | null): asserts node is DefinedTypeNode;
