import type { IdlError } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
export type ErrorNodeMetadata = {
    name: string;
    idlName: string;
    docs: string[];
};
export declare class ErrorNode implements Visitable {
    readonly nodeClass: "ErrorNode";
    readonly metadata: ErrorNodeMetadata;
    readonly code: number;
    readonly message: string;
    constructor(metadata: ErrorNodeMetadata, code: number, message: string);
    static fromIdl(idl: Partial<IdlError>): ErrorNode;
    accept<T>(visitor: Visitor<T>): T;
    get name(): string;
    get docs(): string[];
}
export declare function isErrorNode(node: Node | null): node is ErrorNode;
export declare function assertErrorNode(node: Node | null): asserts node is ErrorNode;
