import type { Idl } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { AccountNode } from './AccountNode';
import type { DefinedTypeNode } from './DefinedTypeNode';
import type { InstructionNode } from './InstructionNode';
import type { Node } from './Node';
import { ProgramNode } from './ProgramNode';
export type ProgramInput = string | Partial<Idl>;
export type ProgramInputs = ProgramInput | ProgramInput[];
export declare class RootNode implements Visitable {
    readonly nodeClass: "RootNode";
    readonly programs: ProgramNode[];
    constructor(programs: ProgramNode[]);
    static fromIdls(idls: Partial<Idl>[]): RootNode;
    static fromProgramInputs(inputs: ProgramInputs): RootNode;
    accept<T>(visitor: Visitor<T>): T;
    get allAccounts(): AccountNode[];
    get allInstructions(): InstructionNode[];
    get allInstructionsWithSubs(): InstructionNode[];
    get allDefinedTypes(): DefinedTypeNode[];
}
export declare function isRootNode(node: Node | null): node is RootNode;
export declare function assertRootNode(node: Node | null): asserts node is RootNode;
