import type { IdlTypeArray, IdlTypeVec } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
import { TypeNumberNode } from './TypeNumberNode';
export declare class TypeArrayNode implements Visitable {
    readonly nodeClass: "TypeArrayNode";
    readonly item: TypeNode;
    readonly size: {
        kind: 'fixed';
        size: number;
    } | {
        kind: 'prefixed';
        prefix: TypeNumberNode;
    } | {
        kind: 'remainder';
    };
    constructor(item: TypeNode, options?: {
        size?: TypeArrayNode['size'];
    });
    static fromIdl(idl: IdlTypeArray | IdlTypeVec): TypeArrayNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeArrayNode(node: Node | null): node is TypeArrayNode;
export declare function assertTypeArrayNode(node: Node | null): asserts node is TypeArrayNode;
