import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNumberNode } from './TypeNumberNode';
export declare class TypeBytesNode implements Visitable {
    readonly nodeClass: "TypeBytesNode";
    readonly size: {
        kind: 'fixed';
        bytes: number;
    } | {
        kind: 'prefixed';
        prefix: TypeNumberNode;
    } | {
        kind: 'variable';
    };
    constructor(options?: {
        size?: TypeBytesNode['size'];
    });
    accept<T>(visitor: Visitor<T>): T;
    getSizeAsString(): string;
    toString(): string;
}
export declare function isTypeBytesNode(node: Node | null): node is TypeBytesNode;
export declare function assertTypeBytesNode(node: Node | null): asserts node is TypeBytesNode;
