import { IdlType } from '../idl';
import type { Node } from './Node';
import { TypeArrayNode } from './TypeArrayNode';
import { TypeBoolNode } from './TypeBoolNode';
import { TypeBytesNode } from './TypeBytesNode';
import { TypeDefinedLinkNode } from './TypeDefinedLinkNode';
import { TypeEnumNode } from './TypeEnumNode';
import { TypeMapNode } from './TypeMapNode';
import { TypeNumberNode } from './TypeNumberNode';
import { TypeNumberWrapperNode } from './TypeNumberWrapperNode';
import { TypeOptionNode } from './TypeOptionNode';
import { TypePublicKeyNode } from './TypePublicKeyNode';
import { TypeSetNode } from './TypeSetNode';
import { TypeStringNode } from './TypeStringNode';
import { TypeStructNode } from './TypeStructNode';
import { TypeTupleNode } from './TypeTupleNode';
export type TypeNode = TypeArrayNode | TypeBoolNode | TypeBytesNode | TypeDefinedLinkNode | TypeEnumNode | TypeMapNode | TypeNumberNode | TypeNumberWrapperNode | TypeOptionNode | TypePublicKeyNode | TypeSetNode | TypeStringNode | TypeStructNode | TypeTupleNode;
export declare const createTypeNodeFromIdl: (idlType: IdlType) => TypeNode;
export declare function isTypeNode(node: Node | null): node is TypeNode;
export declare function assertTypeNode(node: Node | null): asserts node is TypeNode;
export declare function isTypeStructOrDefinedLinkNode(node: Node | null): node is TypeStructNode | TypeDefinedLinkNode;
export declare function assertTypeStructOrDefinedLinkNode(node: Node | null): asserts node is TypeStructNode | TypeDefinedLinkNode;
