import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNumberNode } from './TypeNumberNode';
export type NumberWrapper = {
    kind: 'DateTime';
} | {
    kind: 'SolAmount';
} | {
    kind: 'Amount';
    identifier: string;
    decimals: number;
};
export declare class TypeNumberWrapperNode implements Visitable {
    readonly nodeClass: "TypeNumberWrapperNode";
    readonly item: TypeNumberNode;
    readonly wrapper: NumberWrapper;
    constructor(item: TypeNumberNode, wrapper: NumberWrapper);
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeNumberWrapperNode(node: Node | null): node is TypeNumberWrapperNode;
export declare function assertTypeNumberWrapperNode(node: Node | null): asserts node is TypeNumberWrapperNode;
