import type { IdlTypeOption } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import { TypeNode } from './TypeNode';
import type { Node } from './Node';
import { TypeNumberNode } from './TypeNumberNode';
export declare class TypeOptionNode implements Visitable {
    readonly nodeClass: "TypeOptionNode";
    readonly item: TypeNode;
    readonly prefix: TypeNumberNode;
    readonly fixed: boolean;
    readonly idlType: 'option' | 'coption';
    constructor(item: TypeNode, options?: {
        prefix?: TypeNumberNode;
        fixed?: boolean;
        idlType?: TypeOptionNode['idlType'];
    });
    static fromIdl(idl: IdlTypeOption): TypeOptionNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeOptionNode(node: Node | null): node is TypeOptionNode;
export declare function assertTypeOptionNode(node: Node | null): asserts node is TypeOptionNode;
