import type { IdlTypeSet } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
import { TypeNumberNode } from './TypeNumberNode';
export declare class TypeSetNode implements Visitable {
    readonly nodeClass: "TypeSetNode";
    readonly item: TypeNode;
    readonly size: {
        kind: 'fixed';
        size: number;
    } | {
        kind: 'prefixed';
        prefix: TypeNumberNode;
    } | {
        kind: 'remainder';
    };
    readonly idlType: 'hashSet' | 'bTreeSet';
    constructor(item: TypeNode, options?: {
        size?: TypeSetNode['size'];
        idlType?: TypeSetNode['idlType'];
    });
    static fromIdl(idl: IdlTypeSet): TypeSetNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeSetNode(node: Node | null): node is TypeSetNode;
export declare function assertTypeSetNode(node: Node | null): asserts node is TypeSetNode;
