import { LogLevel } from '../logs';
import * as nodes from '../nodes';
import { NodeStack } from './NodeStack';
export type ValidatorItem = {
    message: string;
    level: LogLevel;
    node: nodes.Node;
    stack: NodeStack;
};
export declare class ValidatorBag {
    readonly items: ValidatorItem[];
    constructor(items?: ValidatorItem[]);
    add(item: ValidatorItem): ValidatorBag;
    mergeWith(others: ValidatorBag[]): ValidatorBag;
    error(message: string, node: nodes.Node, stack: NodeStack): ValidatorBag;
    warn(message: string, node: nodes.Node, stack: NodeStack): ValidatorBag;
    info(message: string, node: nodes.Node, stack: NodeStack): ValidatorBag;
    trace(message: string, node: nodes.Node, stack: NodeStack): ValidatorBag;
    debug(message: string, node: nodes.Node, stack: NodeStack): ValidatorBag;
    orderByLevel(): ValidatorBag;
    log(): void;
}
