import type * as nodes from '../../nodes';
import { Visitor } from '../Visitor';
export declare class GetNodeInlineStringVisitor implements Visitor<string> {
    visitRoot(root: nodes.RootNode): string;
    visitProgram(program: nodes.ProgramNode): string;
    visitAccount(account: nodes.AccountNode): string;
    visitInstruction(instruction: nodes.InstructionNode): string;
    visitDefinedType(definedType: nodes.DefinedTypeNode): string;
    visitError(error: nodes.ErrorNode): string;
    visitTypeArray(typeArray: nodes.TypeArrayNode): string;
    visitTypeDefinedLink(typeDefinedLink: nodes.TypeDefinedLinkNode): string;
    visitTypeEnum(typeEnum: nodes.TypeEnumNode): string;
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant: nodes.TypeEnumEmptyVariantNode): string;
    visitTypeEnumStructVariant(typeEnumStructVariant: nodes.TypeEnumStructVariantNode): string;
    visitTypeEnumTupleVariant(typeEnumTupleVariant: nodes.TypeEnumTupleVariantNode): string;
    visitTypeMap(typeMap: nodes.TypeMapNode): string;
    visitTypeOption(typeOption: nodes.TypeOptionNode): string;
    visitTypeSet(typeSet: nodes.TypeSetNode): string;
    visitTypeStruct(typeStruct: nodes.TypeStructNode): string;
    visitTypeStructField(typeStructField: nodes.TypeStructFieldNode): string;
    visitTypeTuple(typeTuple: nodes.TypeTupleNode): string;
    visitTypeBool(typeBool: nodes.TypeBoolNode): string;
    visitTypeBytes(typeBytes: nodes.TypeBytesNode): string;
    visitTypeNumber(typeNumber: nodes.TypeNumberNode): string;
    visitTypeNumberWrapper(typeNumberWrapper: nodes.TypeNumberWrapperNode): string;
    visitTypePublicKey(): string;
    visitTypeString(typeString: nodes.TypeStringNode): string;
    displayArrayLikeSize(size: nodes.TypeArrayNode['size']): string;
}
